#include <bits/stdc++.h>
using namespace std;
int N,M;
char mat[1037][1037],steve[1007][1007],poz[1007][1007];
queue <int> sj,si,vj,vi;
void bfss(){

}
void bfsf(){

}
int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
   cin >> N >> M ;
   memset(steve, 1, sizeof(steve));
   memset(poz , 1, sizeof(poz));
   for (int i=1;i<=N;i++){
		for (int j=1;j<=M;j++){
			cin >> mat[i][j];
			if (mat[i][j]=='S'){
					si.push(i);
					sj.push(j);
			}
			if (mat[i][j]=='X'){
				vi.push(i);
				vj.push(j);
			}
		}
   }
   bfss();
   bfsf();


	return 0;
}